#include "bot.h"

// bot_game.h

#ifndef __BOTGAME_H__
#define __BOTGAME_H__

#define MAXBOTS 16
#define mobj_t AActor  // zDoom must die forever! ;)


struct Bot_s
{
    mobj_t*    mo;

    fixed_t    forwardmove;
    fixed_t    sidemove;

    int        armor;
    int        frags;

    // Power ups. invinc and invis are tic counters.
    int        powers[NUMPOWERS];
    
	char       team[MAXPLAYERNAME+1];
    int        color;
    char      *name;

    bool       avoidingrocket; // true when a bot is trying to hide
                               // from a rocket
    int        wait;       // for different skill levels
	int        roam;

    bool       GoToThing;
    mobj_t*    thing;

	bool       follow;
	bool       guard;


    int        lastvisitednode;  // for altnode
    bool       ontheway;
    int        routeposition;
    int        destnode;

	//ctf
	bool       flag;

    // Bot's ammo
    int                 cells;
    int                 rockets;
    int                 bullets;
    int                 shells;

    // Bot's current weapon
    int                 weapon;

    // Bot's weapons
    bool                chainsaw;
    bool                sg;
    bool                ssg;
    bool                chaingun;
    bool                rl;
    bool                plasmagun;
    bool                bfg;

    // Counters don't allow to fire very often
    int                 ChainsawCounter;
    int                 PistolCounter;
    int                 PlasmagunCounter;
    int                 RLCounter;
    int                 SSGCounter;
    int                 SGCounter;
    int                 ChainGunCounter;
    int                 BFGCounter;

    // Strafe direction (1 - left, 2 - right)
    int                 StrafeDir;

    bool                BFGshot;
    bool                SSGshot;
    
};
typedef struct Bot_s Bot_t;

extern Bot_t   bots[MAXBOTS];

// names of bots
extern char* botnames[MAXBOTS];
// colors of bots
extern char colors[11][9];

// number of the bots on the map
extern int botnumber;

void InitBots(void);
void B_AddBot(void);
void RemoveAllBots (void);
void BOT_Thinker (mobj_t* mobj);
void BOT_DeathmatchSpawnBot (int botnum);
void BOT_SpawnBot (mapthing2_t* mthing, int botnum);
bool BOT_CheckSpot (mapthing2_t* mthing);
void B_TouchSpecialThing ( mobj_t*       special,
                           mobj_t*       toucher );
void B_CheckPickUp (mobj_t*  toucher);

////////// CTF ///////////

extern bool ctf;

void BOT_SpawnBlueBot (int botnum);

// p_mobj.cpp
void P_SpawnBluePlayer (int playernum);
// g_game.cpp
BOOL G_CheckSpot (int playernum, mapthing2_t *mthing);

//////////////////////////

#endif
