#include "bot.h"
#include "bot_move.h"
#include "bot_node.h"
#include "bot_ctf.h"
           

//
// B_LookForThings
//
bool B_LookForThings (mobj_t* actor)
{
 Bot_t*      b;
 mobj_t*     mo;


 b = &bots[actor->botnum];

 
 if (ctf)
 {
   if (!stricmp(b->team, "red") && b->flag)
   {
     TThinkerIterator<AActor> iterator;
     while ( (mo = iterator.Next() ) )
	 {
		 if (mo->type == MT_RFLAG)
		 {
           if (!P_CheckSight (actor, mo) )
               continue;
           if (!B_CheckMovePtoP (actor, actor, mo))
               continue;
           // move is ok
		   b->thing = mo;
           return true;
		 }

	 }
   }
   
   if (!stricmp(b->team, "blue") && b->flag)
   {
     TThinkerIterator<AActor> iterator;
     while ( (mo = iterator.Next() ) )
	 {
		 if (mo->type == MT_BFLAG)
		 {
           if (!P_CheckSight (actor, mo) )
               continue;
           if (!B_CheckMovePtoP (actor, actor, mo))
               continue;
           // move is ok
		   b->thing = mo;
           return true;
		 }

	 }
   }
 }

 // look for weapons and power ups
 TThinkerIterator<AActor> iterator;
 while ( (mo = iterator.Next() ) )
 {
   if (    (mo->sprite == SPR_MGUN && (!b->chaingun || (!(dmflags & DF_WEAPONS_STAY) && b->bullets < 200) ) )
        || (mo->sprite == SPR_LAUN && (!b->rl || (!(dmflags & DF_WEAPONS_STAY) && b->rockets < 50) ) )
        || (mo->sprite == SPR_PLAS && (!b->plasmagun || (!(dmflags & DF_WEAPONS_STAY) && b->cells < 300) ) )
        || (mo->sprite == SPR_BFUG && (!b->bfg || (!(dmflags & DF_WEAPONS_STAY) && b->cells < 300) ) )
        || (mo->sprite == SPR_SGN2 && (!b->ssg || (!(dmflags & DF_WEAPONS_STAY) && b->shells < 50) ) )
        || (mo->sprite == SPR_SHOT && ((!b->sg || (!(dmflags & DF_WEAPONS_STAY) && b->shells < 50) ) && (!b->ssg || (b->ssg && b->shells < 6) )  ) )
		|| (mo->sprite == SPR_CSAW && !b->chainsaw )
        ||  mo->sprite == SPR_PINV
        ||  mo->sprite == SPR_PINS
      )
   {
       if (!P_CheckSight (actor, mo) )
            continue;
       if (!B_CheckMovePtoP (actor, actor, mo) )
            continue;
       // move is ok
	   b->thing = mo;
       return true;
   }

 }


 if (ctf)
 {
   if (!stricmp(b->team, "red") && !b->flag)
   {
     TThinkerIterator<AActor> iterator;
     while ( (mo = iterator.Next() ) )
	 {
		 if (mo->type == MT_BFLAG)
		 {
           if (!P_CheckSight (actor, mo) )
               continue;
           if (!B_CheckMovePtoP (actor, actor, mo))
               continue;
           // move is ok
		   b->thing = mo;
           return true;
		 }

	 }
   }
   
   if (!stricmp(b->team, "blue") && !b->flag)
   {
     TThinkerIterator<AActor> iterator;
     while ( (mo = iterator.Next() ) )
	 {
		 if (mo->type == MT_RFLAG)
		 {
           if (!P_CheckSight (actor, mo) )
               continue;
           if (!B_CheckMovePtoP (actor, actor, mo))
               continue;
           // move is ok
		   b->thing = mo;
           return true;
		 }

	 }
   }
 }


 if (actor->health < 200 || b->armor < 200)
 {
   TThinkerIterator<AActor> iterator;
   while ( (mo = iterator.Next() ) )
   {
     // thing is found
     if (mo->type == MT_MEGA || mo->sprite == SPR_SOUL)
     {
       if (!P_CheckSight (actor, mo) )
            continue;
       if (!B_CheckMovePtoP (actor, actor, mo))
            continue;
        // move is ok
	   b->thing = mo;
       return true;
     }
   }
 }

 if (b->armor < 200)
 {
   TThinkerIterator<AActor> iterator;
   while ( (mo = iterator.Next() ) )
   {
      // thing is found
     if (mo->type == MT_MISC0 && b->armor >= 100)
          continue; // don't pick up the green armor if already has 100 points
     if (   mo->type == MT_MISC0
         || mo->type == MT_MISC1)
     {
        if (!P_CheckSight (actor, mo) )
             continue;
        if (!B_CheckMovePtoP (actor, actor, mo))
             continue;
         // move is ok
		b->thing = mo;
        return true;
      }
   }
 }

 if (actor->health < 100)
 {
    TThinkerIterator<AActor> iterator;
    while ( (mo = iterator.Next() ) )
	{
      if (   mo->type == MT_MISC10
          || mo->type == MT_MISC11
          || mo->type == MT_MISC13)
       {
         if (!P_CheckSight (actor, mo) )
              continue;
         if (!B_CheckMovePtoP (actor, actor, mo))
              continue;
         // move is ok
		 b->thing = mo;
         return true;
       }
    }
 }

 b->thing = 0;
 return false;
}


//
// B_NeedThing
//
mobj_t* B_NeedThing(mobj_t* actor)
{
 Bot_t*      b;
 mobj_t*     mo;

 b = &bots[actor->botnum];

 if (!node_count) return 0; // no nodes spawned

 if (ctf)
 {
   if (!stricmp(b->team, "red") && b->flag)
   {
     TThinkerIterator<AActor> iterator;
     while ( (mo = iterator.Next() ) )
	 {
		 if (mo->type == MT_RFLAG)
			 return mo;
	 }
   }
   
   if (!stricmp(b->team, "blue") && b->flag)
   {
     TThinkerIterator<AActor> iterator;
     while ( (mo = iterator.Next() ) )
	 {
		 if (mo->type == MT_BFLAG)
			 return mo;
	 }
   }
 }

 // look for weapons
 TThinkerIterator<AActor> iterator;
 while ( (mo = iterator.Next() ) )
 {
   if (    (mo->sprite == SPR_SGN2 && (!b->ssg || (!(dmflags & DF_WEAPONS_STAY) && b->shells < 50) ) )
	    || (mo->sprite == SPR_LAUN && (!b->rl || (!(dmflags & DF_WEAPONS_STAY) && b->rockets < 50) ) )
        || (mo->sprite == SPR_BFUG && (!b->bfg || (!(dmflags & DF_WEAPONS_STAY) && b->cells < 300) ) )        
        || (mo->sprite == SPR_PLAS && (!b->plasmagun || (!(dmflags & DF_WEAPONS_STAY) && b->cells < 300) ) )
      )
   {
	   return mo;
   }
 }

 // look for flag
 if (ctf)
 {
   if (!stricmp(b->team, "red") && !b->flag)
   {
     TThinkerIterator<AActor> iterator;
     while ( (mo = iterator.Next() ) )
	 {
		 if (mo->type == MT_BFLAG)
           return mo;
	 }
   }
   
   if (!stricmp(b->team, "blue") && !b->flag)
   {
     TThinkerIterator<AActor> iterator;
     while ( (mo = iterator.Next() ) )
	 {
		 if (mo->type == MT_RFLAG)
           return mo;
	 }
   }
 }


 if (actor->health < 200 || b->armor < 200)
 {
   TThinkerIterator<AActor> iterator;
   while ( (mo = iterator.Next() ) )
   {
     // thing is found
     if (mo->type == MT_MEGA || mo->sprite == SPR_SOUL)
       return mo;
   }
 }


 if (b->armor < 200)
 {
   TThinkerIterator<AActor> iterator;
   while ( (mo = iterator.Next() ) )
   {
      // thing is found
     if (mo->type == MT_MISC0 && b->armor >= 100)
          continue; // don't pick up the green armor if already has 100 points
     if (mo->type == MT_MISC0 || mo->type == MT_MISC1)
		 return mo;
   }
 }



 return 0;
}


//
// B_FindThingNode
//
int B_FindThingNode(mobj_t* thing)
{
  mobj_t*  bot;
  fixed_t  bestdist=0;
  fixed_t  dist;
  int      bestnode=0;

  if (!thing) return 0;   // a bot doesn't need any thing
  if (!node_count) return 0; // no nodes spawned

  bot = P_SpawnMobj(thing->x, thing->y, ONFLOORZ, MT_DMBOT);

  for (int n=1; n<=node_count; n++)
  {
    if (botnodes[n].special2 == 3) // to make a bot think that
		continue;                  // there is no thing near this node
	if (!P_CheckSight (botnodes[n].mo, thing) )
        continue;
    if (!B_CheckMovePtoP (bot, botnodes[n].mo, thing) )
		continue;

	// find the nearest node
	dist = P_AproxDistance(thing->x - bot->x,
		                   thing->y - bot->y );

	if (!bestdist || dist < bestdist)
	{
		bestdist = dist;
		bestnode = n;
	}

  }

  delete bot;
  return bestnode;
}


//
// B_FindRoutePos
//
void B_FindRoutePos(mobj_t* actor, int dest)
{
  Bot_t*    b;
  int       i;

  b = &bots[actor->botnum];

  for (i=dest; i>=1; i--)
  {
     if (   botnodes[i].special2 == 1 
		 || (b->lastvisitednode >= i 
		     && abs(b->lastvisitednode - i) <= 16) 
	    )
	     continue;     

     if (!B_CheckMovePtoP(actor, actor, botnodes[i].mo) )
         continue;    // impossible to get to this node
      
	 if (abs(b->lastvisitednode - i) <= 3) // skip only long route
		 continue;

     b->routeposition = i;
     b->ontheway = true;

	 break;
  }

}


//
// The bot looks for another bot
//
bool B_LookForBots (mobj_t* actor)
{

 for (int botn=0; botn < botnumber; botn++)
 {
        if (botn == actor->botnum)
           continue;

		if (teamplay.value && bots[botn].mo->IsTeammate (actor))
			continue;

        if (bots[botn].mo->health <= 0)
            continue;           // dead

        if (!P_CheckSight (actor, bots[botn].mo))
            continue;           // out of sight

        actor->target = bots[botn].mo;

        return true;
 }

 actor->target = 0;

 return false;
}
