#include "bot.h"
#include "bot_fire.h"
#include "bot_ctf.h"


void B_CheckPickUp (mobj_t*  toucher)
{
 mobj_t*     mo;
 fixed_t     blockdist;


 TThinkerIterator<AActor> iterator;

 while ( (mo = iterator.Next() ) )
 {
    if (   mo->sprite != SPR_ARM1 && mo->sprite != SPR_ARM2
        && mo->sprite != SPR_BON1 && mo->sprite != SPR_BON2
        && mo->sprite != SPR_SOUL && mo->sprite != SPR_MEGA
        && mo->sprite != SPR_STIM && mo->sprite != SPR_MEDI
        && mo->sprite != SPR_PINV && mo->sprite != SPR_PSTR
        && mo->sprite != SPR_PINS && mo->sprite != SPR_CLIP
        && mo->sprite != SPR_AMMO && mo->sprite != SPR_ROCK
        && mo->sprite != SPR_BROK && mo->sprite != SPR_CELL
        && mo->sprite != SPR_CELP && mo->sprite != SPR_SHEL
        && mo->sprite != SPR_SBOX && mo->sprite != SPR_BPAK
        && mo->sprite != SPR_BFUG && mo->sprite != SPR_MGUN
        && mo->sprite != SPR_CSAW && mo->sprite != SPR_LAUN
        && mo->sprite != SPR_PLAS && mo->sprite != SPR_SHOT
        && mo->sprite != SPR_SGN2 && mo->sprite != SPR_BKEY
		&& mo->sprite != SPR_RKEY)
      continue;

    // Pick up a thing if the bot is near it
    blockdist = toucher->radius + mo->radius;
    if ( abs(toucher->x - mo->x) <= blockdist &&
         abs(toucher->y - mo->y) <= blockdist )
      B_TouchSpecialThing (mo, toucher);
 }

}

//
// B_GivePower
//
void B_GivePower ( Bot_t*  bot,
                   int     power )
{
    if (power == pw_invulnerability)
    {
        bot->powers[power] = INVULNTICS;
        return;
    }

    if (power == pw_invisibility)
    {
        bot->powers[power] = INVISTICS;
        bot->mo->flags |= MF_SHADOW;
        return;
    }
}


void B_TouchSpecialThing ( mobj_t*       special,
                           mobj_t*       toucher )
{
    fixed_t     delta;
    int         sound=1;
    Bot_t*      b;

    b = &bots[toucher->botnum];

    delta = special->z - toucher->z;

    if (delta > toucher->height
        || delta < -8*FRACUNIT)
    {
        // out of reach
        return;
    }

    // Dead thing touching.
    // Can happen with a sliding player corpse.
    if (toucher->health <= 0)
        return;

	b->GoToThing = false;

    // Identify by sprite.
    switch (special->sprite)
    {
        // armor
      case SPR_ARM1:
        if (b->armor < 100)
          b->armor = 100;
        else return;
       break;

      case SPR_ARM2:
        if (b->armor < 200)
          b->armor = 200;
        else return;
       break;

        // bonus items
      case SPR_BON1:
         toucher->health++;
         if (toucher->health > 200) toucher->health = 200;
        break;

      case SPR_BON2:
         b->armor++;
         if (b->armor > 200) b->armor = 200;
        break;

      case SPR_SOUL:
        toucher->health += 100;
        if (toucher->health > 200) toucher->health = 200;
        sound = 2;
       break;

      case SPR_MEGA:
        toucher->health = 200;
        b->armor = 200;
        sound = 2;
       break;


      case SPR_BKEY:
        if (ctf)
        {
           B_BotTouchFlag(toucher, special);
           return;
		}
        break;

      case SPR_YKEY:
        break;

      case SPR_RKEY:
        if (ctf)
        {
           B_BotTouchFlag(toucher, special);
           return;
		}
        break;

      case SPR_BSKU:
        return;

      case SPR_YSKU:
        return;

      case SPR_RSKU:
        return;

        // medikits, heals
      case SPR_STIM:
       if (toucher->health >= 100) return;
       toucher->health += 10;
       if (toucher->health > 100) toucher->health = 100;
        break;

      case SPR_MEDI:
       if (toucher->health >= 100) return;
       toucher->health += 25;
       if (toucher->health > 100) toucher->health = 100;
        break;


        // power ups
      case SPR_PINV:
       B_GivePower (b, pw_invulnerability);
       sound = 2;
        break;

      case SPR_PSTR:
       if (toucher->health < 100) toucher->health = 100;
       sound = 2;
        break;

      case SPR_PINS:
       B_GivePower (b, pw_invisibility);
       sound = 2;
        break;

      case SPR_SUIT:
        break;

      case SPR_PMAP:
        break;

      case SPR_PVIS:
        break;

        // ammo
      case SPR_CLIP:
        break;

      case SPR_AMMO:
        break;

      case SPR_ROCK:
         b->rockets += 1;
        break;

      case SPR_BROK:
        break;

      case SPR_CELL:
        break;

      case SPR_CELP:
        break;

      case SPR_SHEL:
        break;

      case SPR_SBOX:
        break;

      case SPR_BPAK:
        break;

        // weapons
      case SPR_BFUG:
         if (dmflags & DF_WEAPONS_STAY && b->bfg) return;
         b->bfg = true;
         if (dmflags & DF_WEAPONS_STAY) b->cells += 200;
         else b->cells += 80;
         if (b->cells > 300) b->cells = 300;
         B_ChangeWeapon (toucher);
         S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       if (!(dmflags & DF_WEAPONS_STAY)) break;
       S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       return;

      case SPR_MGUN:
         if (dmflags & DF_WEAPONS_STAY && b->chaingun) return;
         b->chaingun = true;
         if (dmflags & DF_WEAPONS_STAY) b->bullets += 100;
         else b->bullets += 40;
         if (b->bullets > 200) b->bullets = 200;
         B_ChangeWeapon (toucher);
         S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       if (!(dmflags & DF_WEAPONS_STAY)) break;
       S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       return;

      case SPR_CSAW:
         if (dmflags & DF_WEAPONS_STAY && b->chainsaw) return;
		 b->chainsaw = true;
		 B_ChangeWeapon(toucher);
         S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       if (!(dmflags & DF_WEAPONS_STAY)) break;
       S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       return;

      case SPR_LAUN:
         if (dmflags & DF_WEAPONS_STAY && b->rl) return;
         b->rl = true;
         if (dmflags & DF_WEAPONS_STAY) b->rockets += 10;
         else b->rockets += 4;
         if (b->rockets > 50) b->rockets = 50;
         B_ChangeWeapon (toucher);
         S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       if (!(dmflags & DF_WEAPONS_STAY)) break;
       S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       return;

      case SPR_PLAS:
         if (dmflags & DF_WEAPONS_STAY && b->plasmagun) return;
         b->plasmagun = true;
         if (dmflags & DF_WEAPONS_STAY) b->cells += 200;
         else b->cells += 80;
         if (b->cells > 300) b->cells = 300;
         B_ChangeWeapon (toucher);
         S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       if (!(dmflags & DF_WEAPONS_STAY)) break;
       S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       return;

      case SPR_SHOT:
         if (dmflags & DF_WEAPONS_STAY && b->sg) return;
         b->sg = true;
         if (dmflags & DF_WEAPONS_STAY) b->shells += 40;
         else b->shells += 16;
         if (b->shells > 50) b->shells = 50;
         B_ChangeWeapon (toucher);
         S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       if (!(dmflags & DF_WEAPONS_STAY)) break;
       S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       return;

      case SPR_SGN2:
         if (dmflags & DF_WEAPONS_STAY && b->ssg) return;
         b->ssg = true;
         if (dmflags & DF_WEAPONS_STAY) b->shells += 40;
         else b->shells += 16;
         if (b->shells > 50) b->shells = 50;
         B_ChangeWeapon (toucher);
         S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       if (!(dmflags & DF_WEAPONS_STAY)) break;
       S_Sound (toucher, CHAN_ITEM, "misc/w_pkup", 1, ATTN_NORM);
       return;

      default:;
    }
		
  if (sound==1) S_Sound (toucher, CHAN_ITEM, "misc/i_pkup", 1, ATTN_NORM);
  if (sound==2) S_Sound (toucher, CHAN_ITEM, "misc/p_pkup", 1, !toucher ? ATTN_SURROUND : ATTN_NORM);

  delete special;
}
