#include "c_console.h"
#include "bot.h"
#include "bot_look.h"


// position of a flag on the base
fixed_t  redbasex;
fixed_t  redbasey;
fixed_t  bluebasex;
fixed_t  bluebasey;

int      redflagreturn;
int      blueflagreturn;


#define RETURNFLAGTIME 600

//
// B_FlagThinker
//      ... ;)
//
void B_FlagThinker(mobj_t* flag)
{
	if (flag->type == MT_RFLAG)
	{
	  if (flag->x != redbasex || flag->y != redbasey)
		  redflagreturn++;

	  if (redflagreturn == RETURNFLAGTIME)
	  {
		  delete flag;
          P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_RFLAG);
		  redflagreturn = 0;
		  return;
	  }
	}
	
	if (flag->type == MT_BFLAG)
	{
	  if (flag->x != bluebasex || flag->y != bluebasey)
		  blueflagreturn++;
	  
	  if (blueflagreturn == RETURNFLAGTIME)
	  {
		  delete flag;
          P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_BFLAG);
		  blueflagreturn = 0;
		  return;
	  }
	}
}

//
// B_AddTeamFrags
//
void B_AddTeamFrags(char* team, int frags)
{
	int i;

	for (i = 0; i < MAXPLAYERS; i++)
	{
		if (playeringame[i] && !stricmp(players[i].userinfo.team, team) )
			players[i].fragcount += frags;
	}

    for (i = 0; i < botnumber; i++)
	{
		if (!stricmp(bots[i].team, team) )
			bots[i].frags += frags;
	}
}


//
// B_PlayerTouchFlag
//
void B_PlayerTouchFlag(player_t* player, mobj_t* special)
{
    // capturing enemy's blue flag
	if (!stricmp(player->userinfo.team, "red") 
		&& special->type == MT_BFLAG)
	{
		player->flag = true;
	    delete special;

		if (player->mo == players[consoleplayer].camera)
		{
		  Printf(PRINT_HIGH, "You got the enemy flag!\n");
          Printf(PRINT_HIGH, "Return to base!\n");
		}
        else
		{
		  if (!strcmp(players[consoleplayer].userinfo.team, "red") )
		  	  Printf(PRINT_HIGH, "Your team got the enemy flag!\n");
          if (!strcmp(players[consoleplayer].userinfo.team, "blue") )
		 	  Printf(PRINT_HIGH, "Your flag was taken!\n");
		}
        
		if (P_Random(pr_botmain) > 50)
		    S_Sound(player->mo, CHAN_VOICE, "doombot/ctftaken", 1, ATTN_NORM);
		else
		    S_Sound(player->mo, CHAN_VOICE, "doombot/ctfunreal", 1, ATTN_NORM);
	}
    
	// touchdown!
	if (!stricmp(player->userinfo.team, "red") 
		&& special->type == MT_RFLAG)
	{
		if (special->x != redbasex || special->y != redbasey)
		{
		  delete special;
          P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_RFLAG);
		  redflagreturn = 0;
		}

		if (player->flag)
		{
		  player->flag = false;
          P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_BFLAG);
		  B_AddTeamFrags("red", 10);
		  
		  if (player->mo == players[consoleplayer].camera)
		  {
		      C_MidPrint ("Touchdown!");
              S_Sound(player->mo, CHAN_VOICE, 
				      "doombot/ctfcap", 1, ATTN_NORM);
			  return;
		  }
		  
		  if (!strcmp(players[consoleplayer].userinfo.team, "blue"))
		  {
			  C_MidPrint("Your flag was captured :-/");
              S_Sound(CHAN_VOICE, "doombot/ctfzombie", 1, ATTN_NORM);
			  return;
		  }
		  
		  if (!strcmp(players[consoleplayer].userinfo.team, "red"))
		  {
			  Printf(PRINT_HIGH, "%s captured the enemy flag!\n", player->userinfo.netname);
              S_Sound(player->mo, CHAN_VOICE, 
				      "doombot/ctfcap", 1, ATTN_NORM);
		  }
		}
	}
    
	// capturing enemy's red flag
	if (!stricmp(player->userinfo.team, "blue") 
		&& special->type == MT_RFLAG)
	{
		player->flag = true;
	    delete special;
        
		if (player->mo == players[consoleplayer].camera)
		{
		  Printf(PRINT_HIGH, "You got the enemy flag!\n");
          Printf(PRINT_HIGH, "Return to base!\n");
		}
        else
		{
		  if (!strcmp(players[consoleplayer].userinfo.team, "blue") )
		  	  Printf(PRINT_HIGH, "Your team got the enemy flag!\n");
          if (!strcmp(players[consoleplayer].userinfo.team, "red") )
		 	  Printf(PRINT_HIGH, "Your flag was taken!\n");
		}

        if (P_Random(pr_botmain) > 50)
		    S_Sound(player->mo, CHAN_VOICE, "doombot/ctftaken", 1, ATTN_NORM);
		else
		    S_Sound(player->mo, CHAN_VOICE, "doombot/ctfunreal", 1, ATTN_NORM);
	}
    
	// touchdown!
	if (!stricmp(player->userinfo.team, "blue") 
		&& special->type == MT_BFLAG)
	{
		if (special->x != bluebasex || special->y != bluebasey)
		{
		  delete special;
		  blueflagreturn = 0;
          P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_BFLAG);
		}
		
		if (player->flag)
		{
		  player->flag = false;
          P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_RFLAG);
		  B_AddTeamFrags("blue", 10);
		  
		  if (player->mo == players[consoleplayer].camera)
		  {
		      C_MidPrint ("Touchdown!");
              S_Sound(player->mo, CHAN_VOICE, 
				      "doombot/ctfcap", 1, ATTN_NORM);
			  return;
		  }
		  
		  if (!strcmp(players[consoleplayer].userinfo.team, "red"))
		  {
			  C_MidPrint("Your flag was captured :-/");
              S_Sound(CHAN_VOICE, "doombot/ctfzombie", 1, ATTN_NORM);
			  return;
		  }
		  
		  if (!strcmp(players[consoleplayer].userinfo.team, "blue"))
		  {
			  Printf(PRINT_HIGH, "%s captured the enemy flag!\n", player->userinfo.netname);
              S_Sound(player->mo, CHAN_VOICE, 
				      "doombot/ctfcap", 1, ATTN_NORM);
		  }
		}
	}
}

//
// B_BotTouchFlag
//
void B_BotTouchFlag(mobj_t* toucher, mobj_t* special)
{
    Bot_t*    b;
    
	b = &bots[toucher->botnum];
    
    // capturing enemy's blue flag
	if (!stricmp(b->team, "red") 
		&& special->type == MT_BFLAG)
	{
		b->flag = true;
	    delete special;

        if (!strcmp(players[consoleplayer].userinfo.team, "red") )
			Printf(PRINT_HIGH, "Your team got the enemy flag!\n");
        if (!strcmp(players[consoleplayer].userinfo.team, "blue") )
			Printf(PRINT_HIGH, "Your flag was taken!\n");
		
		if (P_Random(pr_botmain) > 50)
		    S_Sound(toucher, CHAN_VOICE, "doombot/ctftaken", 1, ATTN_NORM);
		else
		    S_Sound(toucher, CHAN_VOICE, "doombot/ctfunreal", 1, ATTN_NORM);
	}
    
	// touchdown!
	if (!stricmp(b->team, "red") 
		&& special->type == MT_RFLAG)
	{
		if (special->x != redbasex || special->y != redbasey)
		{
		  delete special;
          P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_RFLAG);
		  redflagreturn = 0;
		}

		if (b->flag)
		{
		  b->flag = false;
          P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_BFLAG);
		  B_AddTeamFrags("red", 10);
		  if (!strcmp(players[consoleplayer].userinfo.team, "blue"))
		  {
			  C_MidPrint("Your flag was captured :-/");
              S_Sound(CHAN_VOICE, "doombot/ctfzombie", 1, ATTN_NORM);
		  }
		  if (!strcmp(players[consoleplayer].userinfo.team, "red"))
		  {
			  Printf(PRINT_HIGH, "%s captured the enemy flag!\n", botnames[toucher->botnum]);
              S_Sound(toucher, CHAN_VOICE, 
				      "doombot/ctfcap", 1, ATTN_NORM);
		  }
		}
	}
    
	// capturing enemy's red flag
	if (!stricmp(b->team, "blue") 
		&& special->type == MT_RFLAG)
	{
		b->flag = true;
	    delete special;
        
		if (!strcmp(players[consoleplayer].userinfo.team, "blue") )
			Printf(PRINT_HIGH, "Your team got the enemy flag!\n");
        if (!strcmp(players[consoleplayer].userinfo.team, "red") )
			Printf(PRINT_HIGH, "Your flag was taken!\n");

		if (P_Random(pr_botmain) > 50)
		    S_Sound(toucher, CHAN_VOICE, "doombot/ctftaken", 1, ATTN_NORM);
		else
		    S_Sound(toucher, CHAN_VOICE, "doombot/ctfunreal", 1, ATTN_NORM);
	}
    
	// touchdown!
	if (!stricmp(b->team, "blue") 
		&& special->type == MT_BFLAG)
	{
		if (special->x != bluebasex || special->y != bluebasey)
		{
		  delete special;
		  blueflagreturn = 0;
          P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(bluebasex, bluebasey, ONFLOORZ, MT_BFLAG);
		}

		if (b->flag)
		{
		  b->flag = false;
          P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_IFOG);
		  P_SpawnMobj(redbasex, redbasey, ONFLOORZ, MT_RFLAG);
		  B_AddTeamFrags("blue", 10);
		  if (!strcmp(players[consoleplayer].userinfo.team, "red"))
		  {
			  C_MidPrint("Your flag was captured :-/");
              S_Sound(CHAN_VOICE, "doombot/ctfzombie", 1, ATTN_NORM);
		  }
		  if (!strcmp(players[consoleplayer].userinfo.team, "blue"))
		  {
			  Printf(PRINT_HIGH, "%s captured the enemy flag!\n", botnames[toucher->botnum]);
              S_Sound(toucher, CHAN_VOICE, 
				      "doombot/ctfcap", 1, ATTN_NORM);
		  }
		}
	}
}